	.model	tiny
	.code
	.386
	org	100h
VAL_O	equ	075h
VAL_P	equ	0EBh
VAL_M	equ	1
CharBuf	equ	Start-100h+0F0h
	extrn	B2LDATA
Start:
	lea	dx,BannerM
	call	BailOut
	mov	si,80h
	cld
	xor	ah,ah
	lodsb
	and	al,al
	jz	DoneParse
	lea	dx,HelpM
SkipSpc:	lodsb
	cmp	al,0Dh
	je	DoneParse
	cmp	al,' '
	je	SkipSpc
	mov	ah,VAL_P
	cmp	al,'p'
	je	DonePart
	mov	ah,VAL_O
	cmp	al,'o'
	je	DonePart
	mov	ah,VAL_M
	cmp	al,'m'
	jne	BailOut
DonePart:	lodsb
	cmp	al,' '
	je	DonePart
	cmp	al,0Dh
	jne	BailOut
DoneParse:	cmp	ah,VAL_M
	jne	Patching
	lea	si,MVLFiles
	lea	bp,B2LDATA
	lea	dx,CharBuf
NextMVL:	mov	di,dx
	lodsd
	stosd
	lodsw
	stosw
	and	ah,ah
	jnz	DontFix
	dec	di
DontFix:	mov	eax,'M.H-'
NextVersion:	push	eax
	push	di
	stosd
	mov	eax,'LV'
	stosd
	pop	di

	push	si
	push	dx
	mov	si,dx
	mov	ah,02h
PrintMVL:	lodsb
	and	al,al
	jz	IsNull
	mov	dl,al
	int	21h
	jmp	PrintMVL

IsNull:	mov	dl,' '
	int	21h
	cmp	si,offset CharBuf+13
	jz	DontSpace
	int	21h
DontSpace:
	mov	dl,'.'
	int	21h
	int	21h
	int	21h
	pop	dx
	pop	si

	xor	cx,cx
	mov	ax,4301h
	int	21h	;CHMOD
	mov	ah,3Ch
	call	DoDOS
	mov	bx,ax
	mov	cx,word ptr [si]
	mov	ah,40h
	push	dx
	mov	dx,bp
	call	DoDOS
	cmp	ax,cx
	jne	DOSFailOut
	mov	ah,3Eh
	call	DoDOS

	lea	dx,DoneM
	call	BailOut

	pop	dx
	pop	eax
	xor	ah,'H' xor 'L'
	cmp	ah,'L'
	je	NextVersion
	lodsw
	add	bp,ax
	cmp	al,0A0h
	jne	NextMVL
	ret

Patching:	mov	bp,ax
	lea	di,NameEXE
NextEXE:	mov	si,di
	lodsb
	and	al,al
	jz	Ret1
	call	FindEStr
	mov	dx,di
	call	BailOut
	lea	dx,AfterEXEM
	call	BailOut
	mov	ax,3D02h
	mov	dx,di
	mov	di,si
	int	21h
	jnc	OpenOkay
	cmp	ax,0002h
	jne	DOSFailOut
	lea	dx,MissingM
NextBail:	call	BailOut
	jmp	NextEXE

OpenOkay:	mov	bx,ax
	lea	dx,FileHeadM
	call	BailOut
	lea	si,VersTab
NextVers:	lodsd
	and	eax,eax
	lea	dx,UnknownM
	jz	NextBail
	mov	dx,ax
	ror	eax,16
	mov	cx,ax
	mov	ax,4200h
	call	DoDOS
	mov	ah,3Fh
	lea	dx,CharBuf
	mov	cx,1
	call	DoDOS
	call	Identify
	mov	cx,bp
	lea	dx,EOLM
	and	ch,ch
	jz	NextBail
	lea	dx,NoChgM
	cmp	al,ch
	je	NextBail
	mov	byte ptr [CharBuf],ch
	lea	dx,DoChgM
	call	BailOut
	call	Identify
	mov	ax,4201h
	mov	cx,0FFFFh
	mov	dx,cx
	call	DoDOS
	mov	ah,40h
	lea	dx,CharBuf
	mov	cx,1
	call	DoDOS
	lea	dx,EOLM
	call	BailOut
	jmp	NextEXE

DoDOS:	int	21h
	jnc	Ret1
DOSFailOut:	lea	dx,DOSFailM
	mov	sp,0FFFEh
BailOut:	mov	ah,9
	int	21h
Ret1:	ret

Identify:	mov	al,byte ptr [CharBuf]
	lea	dx,WCDM
	cmp	al,VAL_O
	je	FoundSth
	lea	dx,WoCDM
	cmp	al,VAL_P
	je	FoundSth
	pop	ax
	push	offset NextVers
FindEStr:	lodsb
	cmp	al,'$'
	jne	FindEStr
	ret

FoundSth:	push	ax
	push	dx
	mov	dx,si
	call	BailOut
	mov	ah,02h
	mov	dl,' '
	int	21h
	pop	dx
	call	BailOut
	pop	ax
	ret




BannerM:	db	'PatchD2 v1.1  (c) 2006 [CENSORED] Software',13,10
	db	'Usage: patchd2 [p|o|m]: to enable/disable patch or generate .MVL files',13,10
EOLM:	db	13,10,'$'
HelpM:	db	'Incorrect options!',13,10,'$'
AfterEXEM:	db	8,': ','$'
MissingM:	db	'file missing',13,10,'$'
FileHeadM:	db	'Descent II ','$'
UnknownM:	db	'unknown version/corrupted',13,10,'$'
WCDM:	db	'original','$'
WoCDM:	db	'patched ','$'
NoChgM:	db	', no change needed',13,10,'$'
DoChgM:	db	', changed to ','$'
DOSFailM:	db	13,10,'File I/O failure!',13,10,'$'
DoneM:	db	' done',13,10,'$'
NameEXE:	db	'DESCENT2.EXE',0,'$'
	db	'D2VIRGE.EXE',0,' $'
	db	0

VersTab:
	dd	0CEDE1h	;0A527Dh
	db	'1.1S3V','$'
	dd	0EE045h
	db	'1.0   ','$'
	dd	0F3C5Fh
	db	'1.1   ','$'
	dd	011DB31h
	db	'1.2ftr','$'	;John; conflicts with '1.2'
	dd	0F846Fh
	db	'1.2   ','$'
	dd	0F860Ch
	db	'1.2vtg','$'	;John
	dd	0

MVLFiles:	db	'INTRO',0
	dw	42
	db	'OTHER',0
	dw	382
	db	'ROBOTS'
	dw	416
	end	Start
